# -*- coding: utf-8 -*-

_攝到韻表 = (
    ('通', '東冬鍾'),
    ('江', '江'),
    ('止', '支脂之微'),
    ('遇', '魚虞模'),
    ('蟹', '齊佳皆灰咍祭泰夬廢'),
    ('臻', '真臻文殷魂痕'),
    ('山', '元寒刪山先仙'),
    ('效', '蕭宵肴豪'),
    ('果', '歌'),
    ('假', '麻'),
    ('宕', '唐陽'),
    ('梗', '庚耕清青'),
    ('曾', '登蒸'),
    ('流', '侯尤幽'),
    ('深', '侵'),
    ('咸', '覃談鹽添咸銜嚴凡'),
)

_韻到攝映射表 = {韻: 攝 for 攝, 韻們 in _攝到韻表 for 韻 in 韻們}

def 韻到攝(韻: str) -> str:
    '''
    將韻轉換爲攝。
    
    Examples:

        >>> 韻到攝('冬')
        '通'
        >>> 韻到攝('侵')
        '深'
    '''
    return _韻到攝映射表[韻]
